#
# risc - Ruby Internet Service Checker
#
# written by Taku YASUI
# Copyright (C) Taku YASUI <tach@debian.or.jp>

class Risc
  class Store < Hash

    def initialize(*options)
      init_store(*options)
      get_value.each do |key, value|
        self[key] = value
      end
    end

    def save_alive(host, port=nil, proto='tcp')
      now = Time.now
      key = host
      key = "#{host}:#{proto}:#{port}" if ( port )
      begin
	self[key]['alive_count'] += 1
	self[key]['fails'] = 0
	self[key]['last_alive'] = now
      rescue NameError
        initdb(host, port, proto)
	retry
      end
      set_value(self[key], host, port, proto)
    end

    def save_dead(host, port=nil, proto='tcp')
      now = Time.now
      key = host
      key = "#{host}:#{proto}:#{port}" if ( port )
      begin
	self[key]['dead_count'] += 1
	self[key]['fails'] += 1
	self[key]['last_alive'] = now
      rescue NameError
        initdb(host, port, proto)
	retry
      end
      set_value(self[key], host, port, proto)
    end

    def init_store(*options)
    end

    def set_value(hash, host, port=nil, proto='tcp')
      return true
    end

    def get_value(host=nil, port=nil)
      return {}
    end

    def initdb(host, port=nil, proto='tcp')
      key = host
      key = "#{host}:#{proto}:#{port}" if ( port )
      self[key] = {}
      self[key]['alive_count'] = 0
      self[key]['dead_count'] = 0
      self[key]['fails'] = 0
    end

  end
end
