# sendmail.rb - sendmail plugin for risc

require 'net/smtp'

add_after_check_hook do
  mailserver = @conf.options['sendmail.mailserver'] || 'localhost'
  subject = @conf.options['sendmail.subject'] || 'SERVICE IS DEAD!'
  count =  @conf.options['sendmail.deadcount'] || 2
  body = ''
  @conf.services.each do |host, value|
    if ( @store[host]['fails'] == count )
      body += "#{host}: DEAD! (since: #{@store[host]['last_alive']})\n"
    end
    value.each do |service|
      proto = 'tcp'
      begin
        if ( @store["#{host}:#{proto}:#{service[0]}"]['fails'] == count )
          body += "#{host}:#{proto}:#{service[0]}: DEAD (since: #{@store["#{host}:#{proto}:#{service[0]}"]['last_alive']})\n"
        end
      rescue NoMethodError
        next
      end
    end
  end
  if ( body != '' )
    mail = <<_EOT
From: risc@#{`/bin/hostname -f`.chop}
To: #{@conf.options['sendmail.recipients'].join(", ")}
Subject: #{subject}
Content-Type: text/plain; charset=us-ascii
MIME-Version: 1.0

#{body}
_EOT
    Net::SMTP.start(mailserver) do |smtp|
      smtp.send_mail(mail, "risc@#{`/bin/hostname -f`.chop}", @conf.options['sendmail.recipients'])
    end
    @log.write('This is hook.')
  end
end
